from typing import Optional
from pydantic import BaseModel
from datetime import datetime

class ClassBase(BaseModel):
    name: str
    grade_level: str
    academic_year: str

class ClassCreate(ClassBase):
    pass

class ClassUpdate(BaseModel):
    name: Optional[str] = None
    grade_level: Optional[str] = None
    academic_year: Optional[str] = None

class ClassInDBBase(ClassBase):
    id: int
    created_at: datetime
    updated_at: Optional[datetime] = None

    class Config:
        orm_mode = True

class Class(ClassInDBBase):
    pass