from typing import List
from sqlalchemy.orm import Session
from app.models.class_model import Class
from app.schemas.class_schema import ClassCreate, ClassUpdate
from app.services.base import CRUDBase

class CRUDClass(CRUDBase[Class, ClassCreate, ClassUpdate]):
    def get_by_grade_level(self, db: Session, *, grade_level: str) -> List[Class]:
        return db.query(Class).filter(Class.grade_level == grade_level).all()

    def get_by_academic_year(self, db: Session, *, academic_year: str) -> List[Class]:
        return db.query(Class).filter(Class.academic_year == academic_year).all()

class_service = CRUDClass(Class)