from typing import List
from sqlalchemy.orm import Session
from app.models.subject import Subject
from app.schemas.subject import SubjectCreate, SubjectUpdate
from app.services.base import CRUDBase

class CRUDSubject(CRUDBase[Subject, SubjectCreate, SubjectUpdate]):
    def get_by_class(self, db: Session, *, class_id: int) -> List[Subject]:
        return db.query(Subject).filter(Subject.class_id == class_id).all()

    def get_by_teacher(self, db: Session, *, teacher_id: int) -> List[Subject]:
        return db.query(Subject).filter(Subject.teacher_id == teacher_id).all()

subject_service = CRUDSubject(Subject)